//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma link "Ttcpsock"
#pragma resource "*.dfm"
TServerForm *ServerForm;
int TConnections::count = 0;
//---------------------------------------------------------------------------
__fastcall TServerForm::TServerForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::FormCreate(TObject *Sender)
{
	TCP1->Listen();
  LocalHost->Text = TCP1->LocalHost;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::FormDestroy(TObject *Sender)
{
	TConnections *tmp;
	while( cList){
		tmp = cList;
		cList = cList->next;
		delete tmp;
	}
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::TCP1ConnectRequest(TObject *Sender,
	TSocket requestID)
{
	TConnections *tmp = cList;
	cList = new TConnections( this);
	cList->next = tmp;

	cList->tcp->OnClose = tcpConnectionClosing;
  cList->tcp->OnDataReceived = tcpDataReceived;
	cList->tcp->OnCanWrite = tcpWriteComplete;
	cList->tcp->OnError = tcpError;
	cList->tcp->Accept( requestID);
	Connections->Text = cList->count;
	State->Text = (String)"Connected - " + cList->tcp->RemoteHost + ":"
              + (String)cList->tcp->RemotePort;
  Memo1->Lines->Add( State->Text);
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::tcpConnectionClosing(TObject *Sender)
{
	TConnections *tmp1 = cList, *tmp2=0;
	while( tmp1){
		if( tmp1->tcp == Sender) break;
		tmp2 = tmp1;
		tmp1 = tmp1->next;
	}
	if( tmp1){
		State->Text = (String)"Closed - " + cList->tcp->RemoteHost + ":"
              + (String)cList->tcp->RemotePort;
    Memo1->Lines->Add( State->Text);
		if( tmp2)
			tmp2->next = tmp1->next;
		if( cList == tmp1)
			cList = tmp1->next;
		delete tmp1;
		Connections->Text = cList->count;
	}else{
		Errors->Text = Errors->Text.ToIntDef(0) + 1;
	}
}
//---------------------------------------------------------------------------
TConnections* TServerForm::GetConnection(TObject *Sender)
{
  TConnections *tmp = cList;
	while( tmp){
		if( tmp->tcp == Sender) break;
		tmp = tmp->next;
  }
  return tmp;
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::tcpDataReceived(TObject *Sender)
{
  const int buf_length = 80;
  char buf[buf_length]; memset( buf, buf_length, 0);
	TConnections *tmp = GetConnection( Sender);
  if( tmp){
    int n = tmp->tcp->Read( buf, buf_length);
    if( n){
      buf[n]=0;
      Memo1->Lines->Add( buf);
    }
  }
  else
    Memo1->Lines->Add( "ERROR - Data Received, unknown source!");
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::tcpWriteComplete(TObject *Sender)
{
	TConnections *tmp = GetConnection( Sender);
	if( tmp){
		if( !tmp->welcomed){
			tmp->welcomed = true;
			tmp->tcp->Write( "Welcome!", 8);
		}
	}else
		Memo1->Lines->Add( "ERROR - Write complete, unknown source!");
}
//---------------------------------------------------------------------------
void __fastcall TServerForm::tcpError(TObject *Sender)
{
	TConnections *tmp = GetConnection( Sender);
	if( tmp)
		Memo1->Lines->Add( "Error reported, Remote port " + (String)tmp->tcp->RemotePort);
	else
		Memo1->Lines->Add( "ERROR - Error reported, unknown source!");
}
//---------------------------------------------------------------------------
