//---------------------------------------------------------------------------
#ifndef TTcpSockH
#define TTcpSockH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\winsock.hpp>
//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TAcceptEvent)( System::TObject* Sender, TSocket aSocket);
//---------------------------------------------------------------------------
class TTcpSock : public TComponent
{
private: // data
	static unsigned long refCount;
protected:
  TSocket Socket;
  short fRemotePort;
  short fLocalPort;
  TInAddr fRemoteHost;
  TInAddr fLocalHost;
  TAcceptEvent fOnConnectRequest;
  TNotifyEvent fOnConnect;
  TNotifyEvent fOnClose;
  TNotifyEvent fOnDataReceived;
  TNotifyEvent fOnCanWrite;
  TNotifyEvent fOnError;
private: // methods
  static void InitWinSock();
  static void CloseWinSock();
  void DoConnectRequest();
  void DoConnected();
  void DoClosed();
  void DoDataReceived();
  void DoCanWrite();
  void DoError();
  String __fastcall GetLocalHost();
  String __fastcall GetRemoteHost();
  void __fastcall SetRemoteHost( String host);
protected:
	virtual bool __fastcall WndProc( TMessage& msg);
  String ResolveHostname( TInAddr &host);
  TInAddr LookupHostname( String &host);
  String IpToString( TInAddr &ip);
public:
  __fastcall TTcpSock(TComponent* Owner);
  virtual __fastcall ~TTcpSock();
  void Close();
  void Connect();
  void Listen();
  void Accept( TSocket &sck);
  int Read( char *buf, int len);
  int Write( char *buf, int len);
__published:
  __property String RemoteHost={read=GetRemoteHost,write=SetRemoteHost};
  __property String LocalHost={read=GetLocalHost};
  __property short RemotePort={read=fRemotePort, write=fRemotePort};
  __property short LocalPort={read=fLocalPort, write=fLocalPort};
  __property TAcceptEvent OnConnectRequest={read=fOnConnectRequest, write=fOnConnectRequest};
  __property TNotifyEvent OnConnect={read=fOnConnect, write=fOnConnect};
  __property TNotifyEvent OnClose={read=fOnClose, write=fOnClose};
  __property TNotifyEvent OnDataReceived={read=fOnDataReceived, write=fOnDataReceived};
  __property TNotifyEvent OnCanWrite={read=fOnCanWrite, write=fOnCanWrite};
  __property TNotifyEvent OnError={read=fOnError, write=fOnError};
};
//---------------------------------------------------------------------------
#endif
